package be.iminds.ilabt.jfed.ui.cli2.instruction;

import be.iminds.ilabt.jfed.experiment.setup.ExperimentSetupConfig;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import java.util.List;

public class CredentialInstruction extends InstructionWithSlice {
    @JsonCreator
    public CredentialInstruction(@JsonProperty("action") @Nonnull Action action,
                                 @JsonProperty("user") @Nullable User user,
                                 @JsonProperty("actionOutputs") @Nullable List<ActionOutput> actionOutputs,
                                 @JsonProperty("debugOutputs") @Nullable List<DebugOutput> debugOutputs,
                                 @JsonProperty("callOutputs") @Nullable List<CallOutput> callOutputs,
                                 @JsonProperty("slice") ExperimentSetupConfig.Slice slice) {
        super(action, user, actionOutputs, debugOutputs, callOutputs, slice);
    }

    private CredentialInstruction(boolean demo) {
        super(Action.SLICECREDENTIAL, demo, true);
    }

    @JsonIgnore
    @Nonnull
    @Override
    public Action getActionOfClass() {
        return Action.SLICECREDENTIAL;
    }
}
